/****************************************************************************
 *
 * omp-bug1.c - Exhibits different behavior of GCC >= 9.x
 *
 * Works with GCC < 9.x, compilation error with GCC >= 9.x
 *
 * Written in 2019 by Moreno Marzolla <moreno.marzolla(at)unibo.it>
 *
 * To the extent possible under law, the author(s) have dedicated all 
 * copyright and related and neighboring rights to this software to the 
 * public domain worldwide. This software is distributed without any warranty.
 *
 * You should have received a copy of the CC0 Public Domain Dedication
 * along with this software. If not, see 
 * <http://creativecommons.org/publicdomain/zero/1.0/>. 
 *
 ****************************************************************************/
#include <stdio.h>
#include <omp.h>

int main( void )
{
    const int foo = 1;
#pragma omp parallel default(none)
    {
        int baz = 0;
        baz += foo;
        printf("Thread %d: baz=%d\n", omp_get_thread_num(), baz);
    }
    return 0;
}
