/****************************************************************************
 *
 * omp-lastprivate.c - Demo of the lastprivate clause
 *
 * Last updated in 2017 by Moreno Marzolla <moreno.marzolla(at)unibo.it>
 *
 * To the extent possible under law, the author(s) have dedicated all 
 * copyright and related and neighboring rights to this software to the 
 * public domain worldwide. This software is distributed without any warranty.
 *
 * You should have received a copy of the CC0 Public Domain Dedication
 * along with this software. If not, see 
 * <http://creativecommons.org/publicdomain/zero/1.0/>. 
 *
 * --------------------------------------------------------------------------
 *
 * Compile with:
 * gcc -std=c99 -Wall -Wpedantic -fopenmp omp-lastprivate.c -o omp-lastprivate
 *
 * Run with:
 * OMP_NUM_THREADS=4 ./omp-lastprivate
 *
 ****************************************************************************/
#include <stdio.h>

int main( void )
{
    int tmp = 0, i;
#pragma omp parallel for firstprivate(tmp) lastprivate(tmp)
    for (i = 0; i < 1000; i++) {
        tmp = i;
    }
    printf("%d\n", tmp);
    return 0;
}
